Subject: Re: Emulation codes
From: [email-masked] (Mark Spaeth)
Date: 17 Jan 92 03:05:46 GMT
Newsgroups: comp.sys.apple2

I excerpted this from a huge (178 block) acos help file...

I know the PSE stuff works, because I do pse programming, but I
don't know about the DataMedia 1500, vt100 or vt52...

--------------8<------------------8<--------------8<---------

o Datamedia 1500
 
 This emulation is more or less the standard in the Apple II world since both
 AscII Express and ProTERM (the two most popular terminal programs) fully use
 the entire command set of this emulation with no flaws whatsoever.  AE boots
 up ready-to-rock in this mode; with ProTERM simply set your emulation in the
 dialer or via your online parms.    Most other terminal programs for the IIs
 also support this emulation, so if you want to go with something *EVERYBODY*
 in the Apple II world can enjoy, go with this.
 
Control-H   8 - Cursor Left   <arrow key>   As you will also find below with
Control-J  10 - Cursor Down   <arrow key>   ProTERM Special, DataM uses many
                                            of the same control codes so you
Control-I   9 - Jump to TAB spot            can easily move up to PTS later,
                                            All emulations just about support
once you have exploited DataM to
  the TAB function, so I won't show its fullest.it below, but it still works.
 
Control-L  12 - Clear Screen                 All the codes in DataM excluding
                                             Control-Y are compatible w/ PTS,
Control-Y  25 - Home Position                so I suggest using DataM in very
Control-^  30 - Direct Cursor Positionin     liberal amounts and save PTS for
chr$(30) chr$(x+32) chr$(y+32)               the more detailed areas where ya
                                             could have "two" of everything,
Control-O  14 - Inverse OFF                  one for PTS users only, and one
Control-N  15 - Inverse ON                   for everyone else, where "every-
                                             one else" includes just about da
entire modem population since these control codes generate very few bad effects
on other term programs which don't support DataM seeing as most filter out ctrl
codes anyway. The arrow keys are commonly found on most straight ASCII terms,
and so is TAB and the clear screen.  Inverse ON and OFF tend to generate funny
little characters such as musical notes and whatnot on IBM terminals, but that
isn't such a big deal since it doesn't "ruin" the look, usually.

o ProTERM Special
 
 This emulation is supported only by the terminal program ProTERM at the time
 of this writting. That's bad in a way, since it's not as common as DataM but
 ProTERM *is* widely used by many Apple II owners, so there IS a "market" for
 this emulation. Like DataM, this is a mainly Apple II Only emulation, mainly
 because there's only one program which supports it... But, unlike DataM, you
 can do very VERY fancy things with PTS which could never be done with DataM,
 mainly the music and mousetext.  Of course, because of the mousetext, anyone
 who is using ProTERM Special must also be using an Enhanced Apple II such as
 an Apple IIc, IIgs, or IIe with the newer ROMs and 65c02.
 
Control-E   5 - ID Code, Returns: "Control-]", 29
 
Control-H   8 - Cursor Left   <arrow key>
Control-U  21 - Cursor Right  <arrow key>
Control-J  10 - Cursor Down   <arrow key>
Control-K  11 - Cursor Up     <arrow key>
 
Control-D   4 - Delete Character Under Cursor, Pull Line to Left - no scroll
Control-F   6 - Insert Spacebar Under Cursor, Push Line to Right - no scroll
 
Control-L  12 - Clear Screen
Control-W  23 - Clear from Cursor to End of Screen
Control-Y  25 - Clear from Cursor to End of Line
 
Control-X  24 - Home Position
Control-A   1 - Jump to Column #1
Control-B   2 - Jump to Column #79
Control-^  30 - Direct Cursor Positioning
                chr$(30) chr$(x+32) chr$(y+32)
 
Control-V  22 - Insert Line, Scroll Down
Control-Z  26 - Delete Line, Scroll Up
 
Control-O  14 - Inverse/MouseText OFF
Control-N  15 - Inverse ON
Control-P  16 - MouseText ON
 
Control-R  18 - Repeat Character
                chr$(18) chr$(char) chr$(repeat)
 
Control-T  20 - Tone Generator
                chr$(20) chr$(tone1) chr$(tone2) chr$(duration)
 
  Right now, this is the big "gimic" of many Apple systems across the nation.
  Everybody and their uncle seem to be getting into ProTERM Special, and alot
  of it has become very competitive. If you would like to see ProTERM Special
  at it's "best" I'd suggest you call one of the ProTALK systems in the area,
  such as The Nuclear Escape, (215) 540-9811.  ProTALK is a rewritten GBBS in
  many ways, and still runs under ACOS of course.  The author, Parik Rao, has
  spent many hours thinking up and writting some of the best uses for PTS and
  if you've never seen PTS before, you really should call the Escape.

 
o DEC VT-52
 
  This emulation is among one of the most popular every developed.  Many many
  terminal programs for just about every computer produced support DEC VT-52,
  which is rather limiting but still powerful. I don't have the complete list
  of ESCape codes for this emulation at this time, but I promise many more in
  later releases of these files.  Of course, VT-52 is also OLD and is already
  just about completely replaced with VT-100 but it IS still around so I have
  included it here.  If you want a comprimise between DataM which is Apple II
                                             only more or less, and something
ESC Z   ID Code, Returns: "ESC/Z", 27 47 90  which other folk can enjoy, this
                                             could be it. ProTERM supports it
ESC A   Cursor Up    - no scroll             with no prob and I believe AscII
ESC B   Cursor Down  - no scroll             Express also can use it, plus of
ESC C   Cursor Right - no scroll             course, all the IBM folk who can
ESC D   Cursor Left  - no scroll             enjoy it and all those Commodore
                                             folk with REAL terms and whatnot
ESC I   Cursor Up, With Scroll               so this just may be The Thing!
 
ESC H   Home Position
ESC Y   Direct Cursor Positioning
        chr$(27) chr$(89) chr$(x+32) chr$(y+32)
 
ESC J   Clear from Cursor to End of Screen
ESC K   Clear from Cursor to End of Line

 
o DEC VT-100
 
  This emulation is incredibly common in the MS-DOS world, and many Apple and
  other computers, have terminal programs which support this emulation, which
  is by far the most powerful one listed in this file.  ProTERM Special could
  give it a run  for it's money with the  MouseText and Tones, but DEC VT-100
  is much more powerful even without the tones and I believe there is an ANSI
  subset of VT-100 which allows color graphics and tones(?) among other items
  but I have yet to see an  Apple II term supporting ANSI, since the Apple II
  80 column text screen can't handle color and whatnot. Listed below are alot
  of the ESCape codes found in VT100, but this list is far from complete...
 
ESC Z      ID Code, Returns:  "ESC[?", 27 91 63
 
ESC [#A    Cursor Up    - no scroll
ESC [#B    Cursor Down  - no scroll
ESC [#C    Cursor Right - no scroll
ESC [#D    Cursor Left  - no scroll
 
ESC [#;#H  Direct Cursor Positioning X;Y
ESC [#;#f  Direct Cursor Positioning X;Y
 
ESC [E     New Line (sorta like carriage return)
 
ESC [7     Store Cursor & Attributes
ESC [8     Recall Cursor & Attributes
 
ESC [m     All Attributes Off      You can link these together
ESC [0m    All Attributes Off      with semi-colons, like many
ESC [1m    Bold Face ON            of the other ESCape codes.
ESC [4m    Underscore ON
ESC [5m    Blink ON                Ie: ESC [5;7m
ESC [7m    Inverse ON                  Blink & Inverse ON
 
ESC [K     Clear from Cursor to End of Line
ESC [0K    Clear from Cursor to End of Line
ESC [1K    Clear from Cursor to Start of Line
ESC [2K    Clear entire Line
ESC [J     Clear from Cursor to End of Screen
ESC [0J    Clear from Cursor to End of Screen
ESC [1J    Clear from Cursor to Start of Screen
ESC [2J    Clear Screen
 
ESC [#r    Set Top Of "Window"
ESC [#;#r  Set "Window" size from line # to line #
 
ESC H      Set TAB Spot at current column
ESC [g     Clear TAB at current column
ESC [0g    Clear TAB at current column
ESC [3g    Clear All TAB Spots
 
ESC [6n    Get Cursor Position, Returns: "ESC#;#R"  X;Y
 
The "#" in all of the  above statements refers  to a number, a true ASCII
numeral.  Meaning, when you go ESC[2J to clear the screen, you're sending
exactly that, ESCape, "[", "2", and lastly, "J".   This is different from
all of the above emulations where you would send say, Control-B to do one
of them "2"s since the ASCII value of Control-B is 2 but it is NOT in any
way similiar to the number 2, which is really ASCII value 50!  The direct
cursor positioning works  in the same way,  you send "22", two ASCII 50s,
to say "22" while in the above emulations you would simply send Control-V
to show a 22.   This makes VT-100 a little slower but it's alot easier to
program because you can do PRINT statements litteraly as seen below...
 
 PRINT CHR$(27) "[2;20R";       That one line would set the "window" size
                                from line 2 to line 20 on your monitor...
 
VT100 is, when you really get into, incredibly powerful.  If you would like
to see an Apple system running under ACOS using VT100,  call any one of the
Midway systems, such as The Midnight Tavern at (215) 540-0695 3/12/24 30meg
and you'll get a nice show.  Of course, ALOT of MS-DOS BBS programs support
VT100 and the ANSI graphics and whatnot, but I wrote this file for Apple II
folks and such...since we're "just walking into" this realm...Enjoy!
 
---------------8<-------------------8<----------------8<-------------

Is that a good enough response for ya?
-- 
__   _  ___     __   _
|_) (_` |_  | | | \ | | |\| \ / |\/|            al186@cwns1  i
|   ._) |__ !_! |_/ !_! |\|  |  |\/| lives...                s  Mark Spaeth